//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//
// YASA additional mutex/semaphore definitions
//
// Project:	Yasa 2
// Author :	Jan Blumenthal
// Start  : 2001/11/26
// $Header: /sources/yasa/executives/rtlinux/kernel/include/yasa_rtlinux_mutex.h,v 1.2 2003/01/22 17:02:39 bj Exp $
//
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//
// This program is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2 of the License, or
// (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program (See the included file COPYING);
// if not, write to the Free Software Foundation, Inc.,
// 675 Mass Ave, Cambridge, MA 02139, USA.
//
//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
#ifndef YASA_RTLINUX_MUTEX_INCLUDE
#define	YASA_RTLINUX_MUTEX_INCLUDE


//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
/*
extern inline int pthread_mutexattr_setdynamicceiling_np(pthread_mutexattr_t *attr, YASA_DYN_PRIORITY dprio)
{
	if (attr)
	{
		attr->dynamicceiling=dprio;
		return 0;
	}
	return EINVAL;
}
*/

//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
extern inline int pthread_mutexattr_setpreemptceiling_np(pthread_mutexattr_t *attr, YASA_DYN_PRIORITY preempt)
{
	if (attr)
	{
		attr->preemptceiling=preempt;
		return 0;
	}
	return EINVAL;
}

//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
extern inline int pthread_mutexattr_setname_np(pthread_mutexattr_t *attr, const char *name)
{
	if (attr)
		return yasa_id_set_name( &attr->id, name);
	return 0;
}

//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
extern inline int pthread_mutexattr_setid_np(pthread_mutexattr_t *attr, int id)
{
	if (attr)
		return yasa_id_set_id( &attr->id, id);
	return 0;
}

//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
extern inline int pthread_mutexattr_copyid_np(pthread_mutexattr_t *attr, const YASA_ID *id)
{
	if (attr)
		return yasa_id_copy( &attr->id, id);
	return 0;
}

//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
extern inline int yasa_mutexattr_init(pthread_mutexattr_t *attr)
{
	if ( attr )
	{
		yasa_id_init(&attr->id);
#ifdef YASA_SUPPORT_DYNAMICALLY_SYNCHRONIZATION
		yasa_initdynamicpriority( attr->preemptceiling );
#endif
	}
	return 0;
}








//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
extern inline int yasa_mutex_init(pthread_mutex_t *mutex, const pthread_mutexattr_t *attr)
{
	mutex->id 				= attr->id;
	mutex->thread			= 0;
#ifdef YASA_SUPPORT_DYNAMICALLY_SYNCHRONIZATION
	mutex->preemptceiling	= attr->preemptceiling;
	yasa_initdynamicpriority( attr->dynamicceiling );
//	yasa_initdynamicmutexceilings(mutex);
#endif
	return 0;
}


//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
extern inline int pthread_mutex_setpreemptceiling_np(pthread_mutex_t *mutex, YASA_DYN_PRIORITY *preemptceiling, YASA_DYN_PRIORITY *old_ceiling)
{
	int ret;
	ret = pthread_mutex_lock (mutex);
	if (ret) {
		return ret;
	}
	*old_ceiling = mutex->preemptceiling;
	mutex->preemptceiling = (*preemptceiling);
	pthread_mutex_unlock (mutex);
	return 0;
}

//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
/*
extern inline int pthread_mutex_setdynamicceiling_np(pthread_mutex_t *mutex, YASA_DYN_PRIORITY *dynamicceiling, YASA_DYN_PRIORITY *old_dceiling)
{
	int ret;
	ret = pthread_mutex_lock (mutex);
	if (ret) {
		return ret;
	}
	*old_dceiling = mutex->dynamicceiling;
	mutex->dynamicceiling = (*dynamicceiling);
	pthread_mutex_unlock (mutex);
	return 0;
}
*/

//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
#endif													// ifndef YASA_RTLINUX_MUTEX_INCLUDE