//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//
// YASA rtlinux project startup code
//
// Project: Yasa 2
// Author : Jan Blumenthal
// Start  : 2001/11/26
// $Header: /sources/yasa/executives/rtlinux/sources/logfilereader/yasa_logfilereaderapp.c,v 1.2 2003/01/23 09:18:30 bj Exp $
//
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//
// This program is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2 of the License, or
// (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program (See the included file COPYING);
// if not, write to the Free Software Foundation, Inc.,
// 675 Mass Ave, Cambridge, MA 02139, USA.
//
//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
#include <stdio.h>
#include <fcntl.h>
#include <errno.h>

#define FIFONAMESIZE	255


//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
// arg1=Filename otherwise stdout is used
// arg2=Number of fifo, if no specified 0=will be used
int main(int argc, char *argv[])
{
	int				handle;
	unsigned char	count=0;
	int				retvalue=0;
	int				fifonumber;
	int				fileopened=0;
	char			fifonamebuffer[FIFONAMESIZE];
//	const char		*filename=YASA_LOGFILE_NAME;
	FILE			*outputhandle=stdout;

	if ( argc>=2 )
	{
		outputhandle=fopen( argv[1], "w" );
		if (!outputhandle)
		{
			fprintf(stderr, "Error opening file %s\n", argv[1] );
			exit(errno);
		}
		fileopened=1;
	}

	if ( argc<3 )
		fifonumber=0;
	else
		sscanf( argv[2], "%d", &fifonumber);
	snprintf(fifonamebuffer, FIFONAMESIZE, "/dev/rtf%d", fifonumber);
	printf("Using fifo : %s\n", fifonamebuffer);

	// this reader is using "BLOCKING" Mode!
	if ( (handle = open(fifonamebuffer, O_RDONLY )) >= 0)
	{
		while (count!=0xff)
		{
			while ( ( retvalue=read(handle, &count, 1) ) > 0 )				// read line length
			{
				if (count==0xff) //YASA_LOGEND)
					break;
				fprintf(outputhandle, "%c", count);
			};
			if ( retvalue<0)
				fprintf(stderr, "LogfileReaderApp: Error -1 occured!\n");
			if ( retvalue==0)
				fprintf(stderr, "LogfileReaderApp: Error 0 occured!\n");
		};
		close(handle);
		printf("\nReader ready!\n");
		if ( fileopened )
			close(outputhandle);
		exit(0);
	}
	if ( fileopened )
		close(outputhandle);
	printf("READER: ret:%d\n", retvalue);
	printf("READER: err:%d\n", errno);
	exit(errno);
}


