//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//
// YASA rtlinux project read logfile module
//
// Project: Yasa 2
// Author : Jan Blumenthal
// Start  : 2001/11/26
// $Header: /sources/yasa/executives/rtlinux/sources/logfilereader/yasa_logfilereadermodule.c,v 1.2 2003/01/23 09:18:30 bj Exp $
//
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//
// This program is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2 of the License, or
// (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program (See the included file COPYING);
// if not, write to the Free Software Foundation, Inc.,
// 675 Mass Ave, Cambridge, MA 02139, USA.
//
//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
#include <rtl.h>
#include <rtl_fifo.h>
#include <time.h>
#include <rtl_sched.h>
#include <rtl_sync.h>
#include <pthread.h>
#include <unistd.h>
#include <stdarg.h>


//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
int 	yp_printlogfile(YASA_LOGFILE *logfile, YASA_TIME *schedulerstart, int cpu, void* handle);
struct rtl_sched_cpu_struct rtl_sched [1];
void yasa_printlonglong(void *handle, unsigned INT64 time);


//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
#define 	FIFONAMESIZE	32
long		fifonumber=0;
int			fifosize=4000;
int			filehandle=-1;
pthread_t	thread=0;


//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
void* writer( void* param)
{
	char		max=0xff;
	int			cpu;
	//char		buffer[10];
	YASA_TIME	now;

	// wait until endtime is reached
	now=LOCAL_SCHED->clock->gethrtime(LOCAL_SCHED->clock);
	while ( now < LOCAL_SCHED->schedulerend )
	{
		write(filehandle,"Waiting for end time of scheduler, current time:", 48);
		yasa_printlonglong( &filehandle, now );
		write(filehandle,", end time:", 11);
		yasa_printlonglong( &filehandle, LOCAL_SCHED->schedulerend );
		write(filehandle,"\n", 1);
		write(filehandle," wait for:", 10);
		if ( ( LOCAL_SCHED->schedulerend-now)/1000 < 1000000 )
		{
			yasa_printlonglong( &filehandle, (LOCAL_SCHED->schedulerend-now)/1000 );
			usleep( (LOCAL_SCHED->schedulerend-now)/1000 );
		}
		else
		{
			yasa_printlonglong( &filehandle, (LOCAL_SCHED->schedulerend-now)/1000 );
			usleep(999999);
		}
		write(filehandle,"\n", 1);
		now=LOCAL_SCHED->clock->gethrtime(LOCAL_SCHED->clock);
	};


/*	now=LOCAL_SCHED->clock->gethrtime(LOCAL_SCHED->clock);
	write(filehandle,   "now                : ", 21);
	yasa_printlonglong( &filehandle, now );
	write(filehandle, "\nschedulerstart     : ", 22);
	yasa_printlonglong( &filehandle, LOCAL_SCHED->schedulerstart );
	write(filehandle, "\nendtime            : ", 22);
	yasa_printlonglong( &filehandle, LOCAL_SCHED->schedulerend );
	write(filehandle, " (", 2);
	yasa_printlonglong( &filehandle, LOCAL_SCHED->schedulerend-LOCAL_SCHED->schedulerstart );
	write(filehandle, ")\nschedulertick      : ", 23);
	yasa_printlonglong( &filehandle, LOCAL_SCHED->tick );
	write(filehandle, "\ncalc preemptiontime: ", 22);
	if ( LOCAL_SCHED->calcpreemptiontime )
		write(filehandle, "yes\n", 4);
	else
		write(filehandle, "no\n", 3);
*/

	for ( cpu=0; cpu<YP_MAX_CPU; cpu++ )
	{
		/*sprintf(buffer, "%d", cpu);
		write( filehandle, "YPL: Starting the logfile writing for cpu: ", 43);
		write( filehandle, &buffer, strlen(buffer) );
		write( filehandle, "\n", 1);
		*/
		yp_printlogfile( &rtl_sched[cpu].logfile, &rtl_sched[cpu].schedulerstart, cpu, &filehandle);
	}
	write( filehandle, &max, 1);							// Ready signal

	return 0;
}


//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
int init_module(void)
{
	char		fifoname[FIFONAMESIZE];
	int			retvalue;

	// 8 chars + max. 10 chars for number + 1 (zero) = 19 chars
	sprintf(fifoname, "/dev/rtf%ld", fifonumber);
	printk("Using fifo : %s with size: %d\n", fifoname, fifosize);

	// destroy old fifos and create new one
/*	if ( retvalue=rtf_destroy(fifonumber) )
	{
		printk("YPL:Could not destroy rtfifo %s, error: %d\n", fifoname, -retvalue );
	}
*/
	retvalue=rtf_create(fifonumber, fifosize);
	if ( retvalue )
	{
		printk("YPL:Could not create rtfifo %s, error: %d\n", fifoname, -retvalue );
	}


	filehandle = open(fifoname,O_WRONLY | O_NONBLOCK | O_CREAT );
	if ( filehandle < 0)
	{
		printk("YPL:Could not open rtfifo %s, error: %d\n", fifoname, errno );
		return ENODEV;
	}

/*	do
	{
		now=LOCAL_SCHED->clock->gethrtime(LOCAL_SCHED->clock);
		if ( now >= LOCAL_SCHED->schedulerend )
			break;
	} while (1);
*/

	// create writer thread. If writer could not be created close fifo
	if( pthread_create(&thread, 0, writer, 0) )
	{
		close(filehandle);
		filehandle=0;
		rtf_destroy(fifonumber);
		printk("YPL: Could not create writer thread!\n");
		return ECHILD;
	}
	return 0;
}


//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
void cleanup_module(void)
{
	//int		val=0;

	printk("YPL: CleanupModule entered!\n");
	pthread_cancel( thread );
	pthread_join( thread, 0 );
	rtf_destroy(fifonumber);
	if ( filehandle >= 0 )
	{
		close(filehandle);
/*		if ( val=rtf_destroy(fifonumber) )
			printk("Error %d\n", -val );
*/	}
}
