//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//
// YASA application action handler declarations
// This file contains all information about the actions occured by user interactions
//
// Project: Yasa 2
// Author : Jan Blumenthal
// Start  : 2002/02/28
// $Header: /sources/yasa/yasagui/actionhandler.h,v 1.4 2003/01/24 15:47:40 bj Exp $
//
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//
// This program is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2 of the License, or
// (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program (See the included file COPYING);
// if not, write to the Free Software Foundation, Inc.,
// 675 Mass Ave, Cambridge, MA 02139, USA.
//
//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
#ifndef YASAGUI_ACTIONHANDLER_INCLUDE
#define	YASAGUI_ACTIONHANDLER_INCLUDE

#include <qvector.h>
#include <qaction.h>
#include "yasagui/yasagui.h"
#include "workspacemanager.h"


//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
class YActions;
class QListViewItem;


//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//! This class provides information about the current selected entries or sets
//! Alive from start to end of application
class YActionHandler : public QObject
{ Q_OBJECT
	QArray<YActions*>		actions;
	QWidget					*parentwidget;
	YObject					*object;
	YActions*				_GetActions(unsigned int a)					{	return actions.at(a);	}
	YWorkSpaceManager		&workspacemanager;
public:
	enum	ACTION_TYPES
			{	PROJECTSET_ACTIONS=0		, PROJECT_ACTIONS,
			TASKSET_ACTIONS				, TASK_ACTIONS,
			MUTEXSET_ACTIONS			, MUTEX_ACTIONS,
			ENVIRONMENTSET_ACTIONS		, ENVIRONMENT_ACTIONS,
			SCHEDULERSET_ACTIONS		, SCHEDULER_ACTIONS,
			HEADERSET_ACTIONS			, FILEPATH_ACTIONS,
			SOURCESET_ACTIONS			, RESULTS_ACTIONS,	//WORKSPACE_ACTIONS,
			TIMING_RESULT_ACTIONS		, STATISTIC_RESULT_ACTIONS,
			MAX_ACTIONS };
							YActionHandler(YWorkSpaceManager &wsm) :
							actions(MAX_ACTIONS),
							parentwidget(0),
							object(0),
							workspacemanager(wsm)
							{
							}
							~YActionHandler();
	int						InitInstance(QWidget *widget);
	void					UpdateActions();
	static void				SetCurrentObject(YObject* object);
	static YActions*		GetActions(unsigned int a);
	//! The current object (e.g. selected in last operation like workspace tree)
	YObject*				GetCurrentObject()							{	return object;			}
	QWidget*				GetParentWidget()							{	return parentwidget;	}
	YWorkSpaceManager&		GetWorkSpaceManager()						{	return workspacemanager;}
public slots:
	void					ObjectInvalid()								{	object=0;				}

};




//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
#endif																			// ifndef YASAGUI_ACTIONHANDLER_INCLUDE
