//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//
// YASA project window code
//
// Project: Yasa 2
// Author : Jan Blumenthal
// Start  : 2002/02/28
// $Header: /sources/yasa/yasagui/projectwindow.cpp,v 1.3 2003/01/23 09:18:37 bj Exp $
//
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//
// This program is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2 of the License, or
// (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program (See the included file COPYING);
// if not, write to the Free Software Foundation, Inc.,
// 675 Mass Ave, Cambridge, MA 02139, USA.
//
//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
#include <qlayout.h>
#include <qvbox.h>
#include <qhbox.h>
#include <qgroupbox.h>
#include <qlabel.h>
#include "projectwindow.h"
#include "translations.h"


//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
int YProjectFrame::InitInstance()
{
	YProject			*project=(YProject*)GetObject();

	QFrame				*mainwidget		= new QFrame( GetMainWidget() );
	QVBoxLayout			*vboxlayout		= new QVBoxLayout(mainwidget, MDI_SCROLLVIEW_BORDER );

	QGroupBox	*group1		= new QGroupBox( 5, Horizontal, MSGP_WIDGET_PROPERTIES	, mainwidget );
	QGroupBox	*group2		= new QGroupBox( 1, Horizontal, MSGP_WIDGET_DESCRIPTION	, mainwidget );

	vboxlayout->addWidget( group1 );
	vboxlayout->addWidget( group2 );
	group1->setAlignment(AlignHCenter);
	group2->setAlignment(AlignHCenter);

	// upper group
	QFrame	*upper[]=
	{
		new QVBox( group1 ),
		new QVBox( group1 ),
	};

	new	QLabel(MSGP_WIDGET_NAME					, upper[0] );
	new	QLabel(MSGP_PROJECT_PATH				, upper[0] );
	new QLabel(MSGP_PROJECT_END_TIME			, upper[0] );
	new QLabel(MSGP_PROJECT_TIMER_TICK			, upper[0] );
	new QLabel(MSGP_WIDGET_CPU					, upper[0] );
	new QLabel(MSGP_CALC_PREEMPTIONTIME			, upper[0] );

	new YNameWidget(					project	, upper[1] );
	new YProjectPathWidget(				project	, upper[1] );
	new YEndTimeProjectWidget(			project	, upper[1] );
	new YTickProjectWidget(				project	, upper[1] );
	new YCPUProjectWidget(				project	, upper[1] );
	new YCalcPreemptionTimeProjectWidget(project, upper[1] );


	// lower group
	new YDescriptionWidget( project, group2 );
	scrollview.addChild(mainwidget);
	scrollview.setResizePolicy(QScrollView::AutoOneFit);

	return YObjectFrame::InitInstance();
}
