//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//
// YASA simulation projects administration
//
// Project: Yasa 2
// Author : Jan Blumenthal
// Start  : 2002/02/28
// $Header: /sources/yasa/yasagui/results.cpp,v 1.3 2003/01/23 09:18:37 bj Exp $
//
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//
// This program is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2 of the License, or
// (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program (See the included file COPYING);
// if not, write to the Free Software Foundation, Inc.,
// 675 Mass Ave, Cambridge, MA 02139, USA.
//
//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
#include "results.h"
#include "actionhandler.h"
#include "parser.h"



//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
YResults::YResults(const YResultArgs &args) :
YObject( YObjectArgs(MSGP_CAPTION_RESULTS, YActionHandler::GetActions(YActionHandler::RESULTS_ACTIONS) ) ),
resultargs(args),
timings(),
statistics()
{
	timings.SetParent(this);
	statistics.SetParent(this);
}


//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
YTimingResults::YTimingResults() :
YResult( YObjectArgs(MSGP_CAPTION_TIMINGS, YActionHandler::GetActions(YActionHandler::TIMING_RESULT_ACTIONS) ) )
{}

YStatisticResults::YStatisticResults() :
YResult( YObjectArgs(MSGP_CAPTION_STATISTICS, YActionHandler::GetActions(YActionHandler::STATISTIC_RESULT_ACTIONS) ) )
{}


//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
int YResult::SetConfig(YInputParser &parser)
{
	return parser.SectionEnd();
}

//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
int YResult::GetConfig(YOutputParser &parser)
{
	return parser.SectionEnd();
}

//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
int YResults::SetConfig(YInputParser &parser)
{
	if ( parser.CheckSectionStart(YPC_TIMING) )
		return parser.NewSection(YPC_TIMING, timings);
	if ( parser.CheckSectionStart(YPC_STATISTIC) )
		return parser.NewSection(YPC_STATISTIC, statistics);
	//return YObject::SetConfig(parser);
	return parser.SectionEnd();
}

//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
int YResults::GetConfig(YOutputParser &parser)
{
	int	retvalue;
	retvalue=parser.NewSection(YPC_TIMING, timings );
		if ( retvalue )	return retvalue;
	retvalue=parser.NewSection(YPC_STATISTIC, statistics);
		if ( retvalue )	return retvalue;
	//return YObject::GetConfig(parser);
	return parser.SectionEnd();
}

