//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//
// YASA Timing parser code
//
// Project: Yasa 2
// Author : Jan Blumenthal
// Start  : 2002/02/28
// $Header: /sources/yasa/yasagui/timingparser.cpp,v 1.3 2003/01/23 09:18:39 bj Exp $
//
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//
// This program is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2 of the License, or
// (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program (See the included file COPYING);
// if not, write to the Free Software Foundation, Inc.,
// 675 Mass Ave, Cambridge, MA 02139, USA.
//
//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
#include "timingparser.h"
#include "timingpainter.h"
#include "timings.h"


//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//! Here some feature of the painting function can be set
//! e.g. should the task range be drawn?
void YTimingParser::PrepareLogfilePainting()
{
	ResetParser();
	painter->painterlogfileargs.ResetRangeDrawModes();
}

//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
void YTaskTimingParser::PrepareLogfilePainting()
{
	YTimingParser::PrepareLogfilePainting();
	GetPainter()->painterlogfileargs.drawsystemrange=true;
	GetPainter()->painterlogfileargs.drawtaskrange=true;
	GetPainter()->painterlogfileargs.drawtaskidlerange=true;
	GetPainter()->painterlogfileargs.drawtaskexcludedrange=true;
	GetPainter()->painterlogfileargs.drawjitterrange=true;
}

//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
void YMutexTimingParser::PrepareLogfilePainting()
{
	YTimingParser::PrepareLogfilePainting();
	GetPainter()->painterlogfileargs.drawmutexrange=true;
}
//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
void YCPUTimingParser::PrepareLogfilePainting()
{
	YTimingParser::PrepareLogfilePainting();
	GetPainter()->painterlogfileargs.drawsystemrange=true;
	GetPainter()->painterlogfileargs.drawtaskrange=true;
	GetPainter()->painterlogfileargs.drawtaskidlerange=true;
	GetPainter()->painterlogfileargs.drawtaskexcludedrange=true;
}

//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
bool YTimingParser::TimingFilter(const YLogAction *action) const
{
	return timings->FilterLoggingAction(action);
}
//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
void YTimingParser::EvaluateLoggingEntry(YLogAction *action)
{
	if ( TimingFilter(action) )
		painter->DrawLoggingAction(action, GetTimingRow(action)*timings->GetTimingHeight() );
}
//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
int YTimingParser::GetTimingRow(YLogAction *action) const
{
	return timings->GetLogActionRow(action);
}
