//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//
// YASA timing settings declarations
//
// Project: Yasa 2
// Author : Jan Blumenthal
// Start  : 2002/02/28
// $Header: /sources/yasa/yasagui/timingsettings.h,v 1.4 2003/01/24 15:47:43 bj Exp $
//
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//
// This program is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2 of the License, or
// (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program (See the included file COPYING);
// if not, write to the Free Software Foundation, Inc.,
// 675 Mass Ave, Cambridge, MA 02139, USA.
//
//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
// This file contains settings of the timing windows
//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
#ifndef YASAGUI_TIMING_SETTINGS_INCLUDE
#define	YASAGUI_TIMING_SETTINGS_INCLUDE


//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
#define YTIMING_FIGURE_HEIGHT		16			// must be lower than YTIMING_FIGURE_HEIGHT
#define YTIMING_FIGURE_WIDTH		16			//
#define YTIMING_BAR_HEIGHT			10			// should be lower than YTIMING_FIGURE_HEIGHT
#define YTIMING_TIMING_HEIGHT		YTIMING_FIGURE_HEIGHT
#define YTIMING_TASK_HEIGHT			10			// must be lower than YTIMING_FIGURE_HEIGHT
#define YTIMING_TOP_OFFSET			20			// offset from top of widget to first content
#define YTIMING_SPACING_Y			5
#define YTIMING_SPACING_X			5
#define YTIMING_GRID_LINE_WIDTH		1			// width of the vertical line in the legend
#define YTIMING_GRID_LINE_HEIGHT	1			// height of the horizontal line
#define YTIMING_GRID_LEGEND_WIDTH	3			// width of the vertical square in the legend
#define YTIMING_GRID_LEGEND_HEIGHT	5			// height of the horizontal square
#define YTIMING_EDGE_SPACING_X		10			// space between left window edge and first diagram line (must be higher than YTIMING_SPACING_Y)
//#define YTIMING_EDGE_SPACING_Y		10			// space between top window edge and top point of vertically diagram line
#define YTIMING_NAME_WIDTH			100			// max width of a name to align the timing diagrams
#define YTIMING_DEFAULT_ZOOMFACTOR	1		// logging entries at times between 0-999 are drawn at one pixel
#define YTIMING_DEFAULT_ZOOMFACTOR_CHANGE	2	// double or halve
//#define YTIMING_DEFAULT_ZOOMFACTOR_MAX	10		// minimal zoom factor
#define YTIMING_DEFAULT_LEGENDFACTOR YTIMING_DEFAULT_ZOOMFACTOR*100	// every t=1000000 a legend entry should be painted
#define YTIMING_LEGENDFACTOR_CHANGE	2
#define YTIMING_GRID_COLOR			QColor(0,0,0)


//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
#endif																			// ifndef YASAGUI_TIMING_SETTINGS_INCLUDE
