//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//
// YASA project - Translator
//
// Project: Yasa 2
// Author : Jan Blumenthal
// Start  : 2002/02/28
// $Header: /sources/yasa/yasagui/translator.cpp,v 1.3 2003/01/23 09:18:40 bj Exp $
//
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//
// This program is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2 of the License, or
// (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program (See the included file COPYING);
// if not, write to the Free Software Foundation, Inc.,
// 675 Mass Ave, Cambridge, MA 02139, USA.
//
//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
#include "translator.h"
#include <qtextcodec.h>
#include <qtranslator.h>
#include <qapplication.h>
#include <qdir.h>
#include "yasagui/yasagui_customize.h"


//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
int YTranslator::InitInstance(QApplication *app)
{
	QString	path;

	// translation file for Qt
	qttranslator = new QTranslator(0);

	if ( QString("") == DEFAULT_LANGUAGE )
		path=QDir::currentDirPath() + "/" + LANGUAGE_QT_PREFIX + QTextCodec::locale();
	else
		path=QDir::currentDirPath() + "/" + LANGUAGE_QT_PREFIX + DEFAULT_LANGUAGE;
	qttranslator->load( path + QTextCodec::locale(), "." );
	app->installTranslator( qttranslator );

	if ( QString("") == DEFAULT_LANGUAGE )
		path=QDir::currentDirPath() + "/" + LANGUAGE_YASA_PREFIX + QTextCodec::locale();
	else
		path=QDir::currentDirPath() + "/" + LANGUAGE_YASA_PREFIX + DEFAULT_LANGUAGE;


	// translation file for application strings
	apptranslator = new QTranslator(0);
	apptranslator->load( path, "." );
	app->installTranslator( apptranslator );

	return 0;
}


//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
YTranslator::~YTranslator()
{
	if ( apptranslator )
		delete apptranslator;
	if ( qttranslator )
		delete qttranslator;
}
